Package org.opentcs.components.kernel.services

# Interface InternalVehicleService

All Superinterfaces:
  `TCSObjectService`, `VehicleService`

    public interface InternalVehicleService
    extends VehicleService

Declares the methods the vehicle service must provide which are not accessible to remote peers.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `updateVehicleAllocatedResources​(TCSObjectReference<Vehicle> ref, java.util.List<java.util.Set<TCSResourceReference<?>>> resources)` | Updates a vehicle's allocated resources.
  `void` | `updateVehicleClaimedResources​(TCSObjectReference<Vehicle> ref, java.util.List<java.util.Set<TCSResourceReference<?>>> resources)` | Updates a vehicle's claimed resources.
  `void` | `updateVehicleEnergyLevel​(TCSObjectReference<Vehicle> ref, int energyLevel)` | Updates a vehicle's energy level.
  `void` | `updateVehicleLoadHandlingDevices​(TCSObjectReference<Vehicle> ref, java.util.List<LoadHandlingDevice> devices)` | Updates a vehicle's load handling devices.
  `void` | `updateVehicleNextPosition​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<Point> pointRef)` | Updates the point which a vehicle is expected to occupy next.
  `void` | `updateVehicleOrderSequence​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<OrderSequence> sequenceRef)` | Updates a vehicle's order sequence.
  `void` | `updateVehicleOrientationAngle​(TCSObjectReference<Vehicle> ref, double angle)` | Updates the vehicle's current orientation angle (-360..360 degrees, or `Double.NaN`, if the vehicle doesn't provide an angle).
  `void` | `updateVehiclePosition​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<Point> pointRef)` | Places a vehicle on a point.
  `void` | `updateVehiclePrecisePosition​(TCSObjectReference<Vehicle> ref, Triple position)` | Updates the vehicle's current precise position in mm.
  `void` | `updateVehicleProcState​(TCSObjectReference<Vehicle> ref, Vehicle.ProcState state)` | Updates a vehicle's processing state.
  `void` | `updateVehicleRechargeOperation​(TCSObjectReference<Vehicle> ref, java.lang.String rechargeOperation)` | Updates a vehicle's recharge operation.
  `void` | `updateVehicleRouteProgressIndex​(TCSObjectReference<Vehicle> ref, int index)` | Updates a vehicle's index of the last route step travelled for the current drive order of its current transport order.
  `void` | `updateVehicleState​(TCSObjectReference<Vehicle> ref, Vehicle.State state)` | Updates a vehicle's state.
  `void` | `updateVehicleTransportOrder​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<TransportOrder> orderRef)` | Updates a vehicle's transport order.

  ### Methods inherited from interface org.opentcs.components.kernel.services.TCSObjectService

  `appendObjectHistoryEntry, fetchObject, fetchObject, fetchObjects, fetchObjects, updateObjectProperty`

  ### Methods inherited from interface org.opentcs.components.kernel.services.VehicleService

  `attachCommAdapter, disableCommAdapter, enableCommAdapter, fetchAttachmentInformation, fetchProcessModel, sendCommAdapterCommand, sendCommAdapterMessage, updateVehicleAllowedOrderTypes, updateVehicleIntegrationLevel`

- ## Method Details

  - ### updateVehicleEnergyLevel

    void updateVehicleEnergyLevel​(TCSObjectReference<Vehicle> ref, int energyLevel) throws ObjectUnknownException
    Updates a vehicle's energy level.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `energyLevel` - The vehicle's new energy level.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleLoadHandlingDevices

    void updateVehicleLoadHandlingDevices​(TCSObjectReference<Vehicle> ref, java.util.List<LoadHandlingDevice> devices) throws ObjectUnknownException
    Updates a vehicle's load handling devices.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `devices` - The vehicle's new load handling devices.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleNextPosition

    void updateVehicleNextPosition​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<Point> pointRef) throws ObjectUnknownException
    Updates the point which a vehicle is expected to occupy next.
    Parameters:
      `vehicleRef` - A reference to the vehicle to be modified.
      `pointRef` - A reference to the point which the vehicle is expected to occupy next.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleOrderSequence

    void updateVehicleOrderSequence​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<OrderSequence> sequenceRef) throws ObjectUnknownException
    Updates a vehicle's order sequence.
    Parameters:
      `vehicleRef` - A reference to the vehicle to be modified.
      `sequenceRef` - A reference to the order sequence the vehicle processes.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleOrientationAngle

    void updateVehicleOrientationAngle​(TCSObjectReference<Vehicle> ref, double angle) throws ObjectUnknownException
    Updates the vehicle's current orientation angle (-360..360 degrees, or `Double.NaN`, if the vehicle doesn't provide an angle).
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `angle` - The vehicle's orientation angle.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehiclePosition

    void updateVehiclePosition​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<Point> pointRef) throws ObjectUnknownException
    Places a vehicle on a point.
    Parameters:
      `vehicleRef` - A reference to the vehicle to be modified.
      `pointRef` - A reference to the point on which the vehicle is to be placed.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehiclePrecisePosition

    void updateVehiclePrecisePosition​(TCSObjectReference<Vehicle> ref, Triple position) throws ObjectUnknownException
    Updates the vehicle's current precise position in mm.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `position` - The vehicle's precise position in mm.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleProcState

    void updateVehicleProcState​(TCSObjectReference<Vehicle> ref, Vehicle.ProcState state) throws ObjectUnknownException
    Updates a vehicle's processing state.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `state` - The vehicle's new processing state.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleRechargeOperation

    void updateVehicleRechargeOperation​(TCSObjectReference<Vehicle> ref, java.lang.String rechargeOperation) throws ObjectUnknownException
    Updates a vehicle's recharge operation.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `rechargeOperation` - The vehicle's new recharge action.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleRouteProgressIndex

    void updateVehicleRouteProgressIndex​(TCSObjectReference<Vehicle> ref, int index) throws ObjectUnknownException
    Updates a vehicle's index of the last route step travelled for the current drive order of its current transport order.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `index` - The new index.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleClaimedResources

    void updateVehicleClaimedResources​(TCSObjectReference<Vehicle> ref, java.util.List<java.util.Set<TCSResourceReference<?>>> resources) throws ObjectUnknownException
    Updates a vehicle's claimed resources.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `resources` - The new resources.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleAllocatedResources

    void updateVehicleAllocatedResources​(TCSObjectReference<Vehicle> ref, java.util.List<java.util.Set<TCSResourceReference<?>>> resources) throws ObjectUnknownException
    Updates a vehicle's allocated resources.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `resources` - The new resources.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleState

    void updateVehicleState​(TCSObjectReference<Vehicle> ref, Vehicle.State state) throws ObjectUnknownException
    Updates a vehicle's state.
    Parameters:
      `ref` - A reference to the vehicle to be modified.
      `state` - The vehicle's new state.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.

  - ### updateVehicleTransportOrder

    void updateVehicleTransportOrder​(TCSObjectReference<Vehicle> vehicleRef, TCSObjectReference<TransportOrder> orderRef) throws ObjectUnknownException
    Updates a vehicle's transport order.
    Parameters:
      `vehicleRef` - A reference to the vehicle to be modified.
      `orderRef` - A reference to the transport order the vehicle processes.
    Throws:
      `ObjectUnknownException` - If the referenced vehicle does not exist.